// 父类 GameObj
class GameObj {
    constructor(name) {
        this.name = name;
    }

    move() {
        console.log(`${this.name}进行了移动`);
    }
}

// NPC 子类
class NPC extends GameObj {
    constructor(name, title) {
        super(name);
        this.title = title || "普通";
        this.name = "NPC-" + name; // 复写name属性
    }

    talk() {
        console.log(`${this.title}头衔的${this.name}进行了说话`);
    }
}

// Enemy 子类
class Enemy extends GameObj {
    constructor(name, hp) {
        super(name);
        this.hp = hp || 100;
        this.name = "Enemy-" + name; // 复写name属性
    }

    attack() {
        console.log(`${this.hp}血量的${this.name}进行了攻击`);
    }
}

module.exports = { GameObj, NPC, Enemy };