// 父类 基础物品
function BaseItem(name) {
    this.name = name || "基础物品";
}

BaseItem.prototype.discard = function() {
    console.log(`${this.name}被丢弃了`);
};

// 子类 消耗物品类
function ConsumableItem(name, consume) {
    BaseItem.call(this, name);
    this.name = "消耗物品-" + (name || "默认"); // 覆盖name属性
    this.consume = consume || 1;
}

ConsumableItem.prototype = Object.create(BaseItem.prototype);
ConsumableItem.prototype.constructor = ConsumableItem;

ConsumableItem.prototype.use = function() {
    console.log(`使用了${this.consume}个:${this.name}`);
};

// 子类 装备类
function EquipmentItem(name, naijiu) {
    BaseItem.call(this, name);
    this.name = "装备-" + (name || "默认"); // 覆盖name属性
    this.naijiu = naijiu || 100;
}

EquipmentItem.prototype = Object.create(BaseItem.prototype);
EquipmentItem.prototype.constructor = EquipmentItem;

EquipmentItem.prototype.equip = function() {
    console.log(`装备了${this.name},这件装备还有:${this.naijiu}点耐久`);
};

module.exports = { BaseItem, ConsumableItem, EquipmentItem };